SystemOrganization addCategory: #'Magritte-Seaside-Components'!
SystemOrganization addCategory: #'Magritte-Seaside-Renderer'!
SystemOrganization addCategory: #'Magritte-Seaside-Examples'!

!MAContainer class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:34'!
defaultComponentClass
	^MAContainerComponent! !

!MAContainer methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:09'!
acceptRenderer: aRenderer
	aRenderer renderContainer: self.! !

WAComponent subclass: #MAComponent
	instanceVariableNames: 'model description renderer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAComponent class methodsFor: 'accessing-defaults' stamp: 'lr 3/10/2005 23:06'!
defaultRenderer
	^MATableRenderer new! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 11/28/2004 19:10'!
model: aModel
	^self model: aModel description: aModel description.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 20:20'!
model: aModel description: aDescription
	^self model: aModel description: aDescription renderer: self defaultRenderer.! !

!MAComponent class methodsFor: 'instance creation' stamp: 'lr 12/20/2004 18:25'!
model: aModel description: aDescription renderer: aRenderer
	^self new
		model: aModel;
		description: aDescription;
		renderer: aRenderer;
		yourself.! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm
	self addForm: #( save cancel ).! !

!MAComponent methodsFor: 'forms' stamp: 'lr 2/28/2005 16:14'!
addForm: aCollection
	self addDecoration: (WAFormDecoration new 
		buttons: aCollection;
		yourself).! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:08'!
buildComponent: anObject
	^self 
		buildComponent: anObject 
		description: anObject description.! !

!MAComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:27'!
buildComponent: anObject description: aDescription
	^(aDescription asComponentOn: anObject)
		renderer: self renderer;
		yourself.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
cancel
	self answer: nil.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:21'!
commit! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description
	^description! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
description: anObject
	description := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model
	^model! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 2/28/2005 16:14'!
model: anObject
	model := anObject! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:00'!
readonly
	^self renderer readonly! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:00'!
readonly: aBoolean
	self renderer readonly: aBoolean.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
refresh! !

!MAComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:13'!
renderContentOn: html
	self renderer
		component: self;
		html: html;
		visit: self description.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 22:29'!
renderEditorOn: html 
	self renderViewerOn: html.! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 2/28/2005 16:14'!
renderLabelOn: html
	self description label isEmptyOrNil
		ifFalse: [ html render: self description label; text: ':' ].! !

!MAComponent methodsFor: 'rendering-parts' stamp: 'lr 3/3/2005 15:18'!
renderViewerOn: html 
	html render: self cache.! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/3/2005 16:16'!
renderer
	^renderer! !

!MAComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:08'!
renderer: aRenderer
	renderer := aRenderer! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset! !

!MAComponent methodsFor: 'actions' stamp: 'lr 2/28/2005 16:14'!
save
	self commit; answer: self model.! !

!MAComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate! !

MAComponent subclass: #MAContainerComponent
	instanceVariableNames: 'children'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAContainerComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:32'!
buildChildren
	^Array streamContents: [ :stream |
		self description do: [ :each |
			each isVisible ifTrue: [
				stream nextPut: (self
					buildComponent: self model 
					description: each) ] ] ].! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:31'!
children
	children isNil
		ifTrue: [ self children: self buildChildren ].
	^children.! !

!MAContainerComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 22:06'!
children: aCollection
	children := aCollection! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 21:59'!
commit
	super commit.
	self children do: [ :each | each commit ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:06'!
refresh
	super refresh.
	self children: nil.! !

!MAContainerComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:48'!
renderViewerOn: html 
	self children do: [ :each | html render: each ].! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
reset
	super reset.
	self children do: [ :each | each reset ].
! !

!MAContainerComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 22:02'!
validate
	super validate.
	self children do: [ :each | each validate ].! !

MAComponent subclass: #MAElementComponent
	instanceVariableNames: 'cache'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

MAElementComponent subclass: #MACheckboxComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:47'!
renderEditorOn: html
	html label: [
		html checkboxOn: #cache of: self. 
		html render: self description label ].! !

!MACheckboxComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:07'!
renderLabelOn: html! !

MAElementComponent subclass: #MADateInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MADateInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:58'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		dateInputWithValue: self cache 
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

!MAElementComponent methodsFor: 'private' stamp: 'lr 3/10/2005 22:40'!
buildCache
	^self description read: self model.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:20'!
cache
	cache isNil
		ifTrue: [ self cache: self buildCache ].
	^cache.! !

!MAElementComponent methodsFor: 'accessing' stamp: 'lr 3/9/2005 22:20'!
cache: anObject
	cache := anObject! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/10/2005 12:04'!
commit
	super commit.
	self description isReadonly 
		ifTrue: [ ^self ].
	self description 
		write: self cache
		to: self model.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
reset
	super reset.
	self cache: nil.! !

!MAElementComponent methodsFor: 'actions' stamp: 'lr 3/9/2005 22:22'!
validate
	super validate.
	self description coerce: self cache.! !

MAElementComponent subclass: #MAFileUploadComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAFileUploadComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderEditorOn: html 
	html attributes: self description attributes.
	html fileUploadWithCallback: [ :file | self cache: file ].! !

MAElementComponent subclass: #MAOptionsComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:37'!
renderEditorOn: html
	self 
		renderList: self description options
		selected: self cache
		callback: [ :value | self cache: value ]
		labels: self description labelBlock
		on: html.! !

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 21:59'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	self subclassResponsibility.! !

!MAOptionsComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:05'!
renderViewerOn: html
	html render: (self description labelBlock value: self cache).! !

MAOptionsComponent subclass: #MARadioGroupComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MARadioGroupComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:35'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html radioGroup in: [ :group |
		aCollection do: [ :each |
			html label: [
				html attributes: self description attributes.
				html 
					radioButtonInGroup: group
					selected: each = anObject
					callback: [ aCallbackBlock value: each ].
				html render: (aLabelBlock value: each) ] ] ].! !

MAOptionsComponent subclass: #MASelectListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MASelectListComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:15'!
renderList: aCollection selected: anObject callback: aCallbackBlock labels: aLabelBlock on: html
	html attributes: self description attributes.
	html 
		selectFromList: aCollection
		selected: anObject
		callback: aCallbackBlock
		labels: aLabelBlock.! !

MAElementComponent subclass: #MATextAreaComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextAreaComponent methodsFor: 'rendering' stamp: 'lr 3/9/2005 22:17'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textAreaOn: #cache of: self.! !

MAElementComponent subclass: #MATextInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:33'!
renderEditorOn: html 
	html attributes: self description attributes.
	html textInputOn: #cache of: self.! !

MAElementComponent subclass: #MATextPasswordComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATextPasswordComponent methodsFor: 'commit' stamp: 'lr 3/10/2005 23:27'!
commit
	(self cache allSatisfy: [ :each | each = $* ])
		ifFalse: [ super commit ].! !

!MATextPasswordComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 23:24'!
obfuscated
	^String new: self cache size withAll: $*.! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:25'!
renderEditorOn: html 
	html attributes: self description attributes.
	html 
		passwordInputWithValue: self obfuscated
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

!MATextPasswordComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:24'!
renderViewerOn: html 
	html render: self obfuscated.! !

MAElementComponent subclass: #MATimeInputComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Components'!

!MATimeInputComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 22:58'!
renderEditorOn: html
	html attributes: self description attributes.
	html 
		timeInputWithValue: self cache 
		callback: (MessageSend 
			receiver: self 
			selector: #cache:).! !

WAComponent subclass: #MAMockComponent
	instanceVariableNames: 'model'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Examples'!

!MAMockComponent class methodsFor: 'class initialization' stamp: 'lr 3/10/2005 15:12'!
initialize
	self registerAsApplication: 'magritte'.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model
	model isNil
		ifTrue: [ self model: MAMockModel new ].
	^model.! !

!MAMockComponent methodsFor: 'accessing' stamp: 'lr 3/10/2005 15:02'!
model: aModel
	model := aModel! !

!MAMockComponent methodsFor: 'rendering' stamp: 'lr 3/10/2005 23:01'!
renderContentOn: html
	html 
		anchorWithCallback: [ self call: self model asComponent addForm ]
		do: 'show form'.
	html text: ' '.
	html
		anchorWithCallback: [ self call: (self model asComponent 
			readonly: true; addForm; yourself) ]
		do: 'show view'.  
	html layoutTable: [
		html tableRow: [
			html tableHeading: 'Key'.
			html tableHeading: 'Label'.
			html tableHeading: 'Priority'.
			html tableHeading: 'Default'.
			html tableHeading: 'Visibility'.
			html tableHeading: 'Readonly'.
			html tableHeading: nil ].
		self model description do: [ :each |
			html tableRow: [
				html tableData: each key.
				html tableData: each label.
				html tableData: each priority.
				html tableData: each default.
				html tableData: each visible.
				html tableData: each readonly.
				html tableData: [
					html 
						anchorWithAction: [ self call: each asComponent addForm ]
						do: 'edit' ] ] ] ].! !

Object subclass: #MARenderer
	instanceVariableNames: 'html component readonly'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

MARenderer subclass: #MACssRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:51'!
renderContainer: aDescription
	html divClass: 'container' with: [ super renderContainer: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderEditor: aDescription
	html divClass: 'editor' with: [ super renderEditor: aDescription ].! !

!MACssRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:52'!
renderElement: aDescription
	html divClass: 'element' with: [ super renderElement: aDescription ].! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderLabel: aDescription
	html divClass: 'label' with: [ super renderLabel: aDescription ].
! !

!MACssRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:24'!
renderViewer: aDescription
	html divClass: 'viewer' with: [ super renderViewer: aDescription ].! !

!MARenderer class methodsFor: 'instance creation' stamp: 'lr 3/10/2005 21:02'!
in: aComponent on: aRenderer
	^self new
		component: aComponent;
		html: aRenderer;
		yourself.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component
	^component! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
component: aComponent
	component := aComponent! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html
	^html! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:02'!
html: aRenderer
	html := aRenderer! !

!MARenderer methodsFor: 'initialize-release' stamp: 'lr 3/10/2005 22:13'!
initialize
	super initialize.
	self readonly: false.! !

!MARenderer methodsFor: 'testing' stamp: 'lr 3/10/2005 21:18'!
isReadonly
	^self readonly.! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly
	^readonly! !

!MARenderer methodsFor: 'accessing' stamp: 'lr 3/10/2005 21:17'!
readonly: aBoolean
	readonly := aBoolean! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderContainer: aDescription
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderEditor: aDescription
	self component renderEditorOn: html.! !

!MARenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:50'!
renderElement: aDescription
	self renderLabel: aDescription.
	self renderWidget: aDescription.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderLabel: aDescription
	self component renderLabelOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:17'!
renderViewer: aDescription
	self component renderViewerOn: html.! !

!MARenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:51'!
renderWidget: aDescription
	(self isReadonly or: [ aDescription isReadonly ])
		ifTrue: [ self renderViewer: aDescription ]
		ifFalse: [ self renderEditor: aDescription ].! !

!MARenderer methodsFor: 'visiting' stamp: 'lr 3/10/2005 22:12'!
visit: aDescription
	aDescription acceptRenderer: self.! !

MARenderer subclass: #MATableRenderer
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Magritte-Seaside-Renderer'!

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:55'!
renderContainer: aDescription
	html table: [ super renderWidget: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering' stamp: 'lr 3/10/2005 21:28'!
renderElement: aDescription
	html tableRow: [ super renderElement: aDescription ].
! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:22'!
renderLabel: aDescription
	html tableHeading: [ super renderLabel: aDescription ].! !

!MATableRenderer methodsFor: 'rendering-parts' stamp: 'lr 3/10/2005 21:30'!
renderWidget: aDescription
	html tableData: [ super renderWidget: aDescription ].! !

!Object methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:25'!
asComponent
	"Return a generic Seaside component of the receiver."

	^self description asComponentOn: self.! !

!MABoolean class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:45'!
defaultComponentClass
	^MACheckboxComponent! !

!MATime class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATimeInputComponent! !

!MABinary class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:35'!
defaultComponentClass
	^MAFileUploadComponent! !

!MAElement class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:31'!
defaultAttributes
	^Dictionary new.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:10'!
acceptRenderer: aRenderer
	aRenderer renderElement: self.! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:32'!
attributes
	^self 
		propertyAt: #attributes 
		ifAbsent: [ self class defaultAttributes ].! !

!MAElement methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
attributes: aDictionary
	^self propertyAt: #attributes put: aDictionary.! !

!MANumber class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MADate class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MADateInputComponent! !

!MAString class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MATextInputComponent! !

!MADescription class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 22:25'!
defaultComponentClass
	self subclassResponsibility! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 21:05'!
acceptRenderer: aRenderer
	self subclassResponsibility.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/9/2005 22:28'!
asComponentOn: anObject
	^self componentClass model: anObject description: self.! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass
	^self propertyAt: #componentClass ifAbsent: [ self class defaultComponentClass ].! !

!MADescription methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:33'!
componentClass: aClass
	^self propertyAt: #componentClass put: aClass.! !

!MAPassword class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextPasswordComponent! !

!MAText class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:37'!
defaultComponentClass
	^MATextAreaComponent! !

!MASelection class methodsFor: '*Magritte-Seaside' stamp: 'lr 3/10/2005 10:36'!
defaultComponentClass
	^MASelectListComponent! !
MAMockComponent initialize!
